"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var test_utils_1 = require("react-dom/test-utils");
var react_1 = require("./react");
var counterStore = react_1.default({ count: 0 });
var Counter = function () {
    var _a = counterStore.usePureStore(), state = _a[0], update = _a[1];
    return (React.createElement("div", null,
        React.createElement("span", null, state.count),
        React.createElement("button", { onClick: function () { return update(function (s) { return s.count++; }); } }, "+"),
        React.createElement("button", { onClick: function () { return update(function (s) { return s.count--; }); } }, "-")));
};
var container;
beforeEach(function () {
    container = document.createElement('div');
    document.body.appendChild(container);
});
afterEach(function () {
    document.body.removeChild(container);
    container = null;
});
describe("Using a component with usePureStore()", function () {
    test("Renders as expected", function () {
        test_utils_1.act(function () { ReactDOM.render(React.createElement(Counter, null), container); });
        var count = container.querySelector("span").textContent;
        expect(count).toBe("0");
    });
    test("Works with interaction and updates", function () {
        test_utils_1.act(function () { ReactDOM.render(React.createElement(Counter, null), container); });
        var _a = container.querySelectorAll("button"), inc = _a[0], dec = _a[1];
        test_utils_1.act(function () {
            for (var i = 0; i < 12; i++) {
                inc.dispatchEvent(new MouseEvent('click', { bubbles: true }));
            }
            dec.dispatchEvent(new MouseEvent('click', { bubbles: true }));
        });
        var count = container.querySelector("span").textContent;
        expect(count).toBe("11");
    });
});
var store = react_1.default({
    lists: [
        {
            date: new Date(),
            completed: false,
            items: [
                {
                    name: "eggs",
                    purchased: false
                },
                {
                    name: "bread",
                    purchased: true
                },
                {
                    name: "eggs",
                    purchased: false
                }
            ]
        },
        {
            date: new Date(+new Date() - 86400000),
            completed: true,
            items: [
                {
                    name: "vinegar",
                    purchased: true
                }
            ]
        }
    ]
});
var ShoppingApp = function () {
    var state = store.usePureStore()[0];
    return (React.createElement("div", { className: "shopping-app" },
        React.createElement("h1", null,
            "Shopping",
            React.createElement("small", null,
                state.lists.length,
                " ",
                "lists, ",
                state.lists.filter(function (d) { return !d.completed; }).length,
                " uncompleted")),
        React.createElement(NextDueList, null)));
};
var NextDueList = React.memo(function () {
    var _a = store.usePureStore(function (s) { return s.lists.find(function (l) { return l.completed == false; }); }), state = _a[0], update = _a[1];
    // If there are no lists due:
    if (!state)
        return null;
    var date = state.date, completed = state.completed, items = state.items;
    return (React.createElement("div", { className: "list" },
        React.createElement("h3", null,
            "List for ",
            date.toLocaleString(),
            React.createElement("small", null,
                items.length,
                " items, ",
                items.filter(function (d) { return !d.purchased; }).length,
                " unpurchased")),
        React.createElement("input", { type: "checkbox", checked: completed, onChange: function () { return update({ completed: !completed }); } }),
        React.createElement("ul", null, items.map(function (item, i) {
            return React.createElement("li", { key: i },
                React.createElement("label", null,
                    item.name,
                    React.createElement("input", { type: "checkbox", checked: completed, onChange: function (e) { return update(function (s) { return s.items[i].purchased = e.target.checked; }); } })));
        }))));
});
describe("Using usePureStore with a getter", function () {
    test("Renders as expected", function () {
        test_utils_1.act(function () { ReactDOM.render(React.createElement(ShoppingApp, null), container); });
        var text = container.querySelector("h1 small").textContent;
        expect(text).toBe("2 lists, 1 uncompleted");
        var listDescription = container.querySelector("h3 small").textContent;
        expect(listDescription).toBe("3 items, 2 unpurchased");
    });
    test("Works with interaction and updates", function () { return __awaiter(void 0, void 0, void 0, function () {
        var listDescription, appDescription;
        return __generator(this, function (_a) {
            test_utils_1.act(function () { ReactDOM.render(React.createElement(ShoppingApp, null), container); });
            test_utils_1.act(function () {
                var eggCheckbox = container.querySelector(".list ul input");
                eggCheckbox.dispatchEvent(new MouseEvent('click', { bubbles: true }));
            });
            listDescription = container.querySelector("h3 small").textContent;
            expect(listDescription).toBe("3 items, 1 unpurchased");
            test_utils_1.act(function () {
                var checkbox = container.querySelector(".list > input");
                checkbox.dispatchEvent(new MouseEvent('click', { bubbles: true }));
            });
            appDescription = container.querySelector("h1 small").textContent;
            expect(appDescription).toBe("2 lists, 0 uncompleted");
            return [2 /*return*/];
        });
    }); });
});
var renderStore = react_1.default({ count: 0 });
var RenderTest = React.memo(function () {
    var count = renderStore.usePureStore()[0].count;
    return React.createElement("span", null,
        count,
        " - ",
        Math.random());
});
describe("Using a component with usePureStore()", function () {
    test("Re-renders with new values", function () {
        test_utils_1.act(function () { ReactDOM.render(React.createElement(RenderTest, null), container); });
        var value1 = container.querySelector("span").textContent;
        test_utils_1.act(function () {
            renderStore.update(function (s) { return s.count++; });
            ReactDOM.render(React.createElement(RenderTest, null), container);
        });
        var value2 = container.querySelector("span").textContent;
        expect(value1).not.toBe(value2);
    });
    test("Does not re-render with unchanged values", function () {
        test_utils_1.act(function () { ReactDOM.render(React.createElement(RenderTest, null), container); });
        var value1 = container.querySelector("span").textContent;
        test_utils_1.act(function () {
            renderStore.update(function (s) { return s.count = s.count; });
            ReactDOM.render(React.createElement(RenderTest, null), container);
        });
        var value2 = container.querySelector("span").textContent;
        expect(value1).toBe(value2);
    });
});
